// Easy Video Frame LIBrary "evflib.h" by I.N.

// OS:Windows XP/Vista/7
// Compiler:Visual C++ 2008 Professional

// 2013/08/13-9/2 ver.1.0 

#pragma once
#define EVFLIB_H

//#define EVF_DEBUG

#include <dshow.h>
#pragma include_alias( "dxtrans.h", "qedit.h" )
#define __IDxtCompositor_INTERFACE_DEFINED__
#define __IDxtAlphaSetter_INTERFACE_DEFINED__
#define __IDxtJpeg_INTERFACE_DEFINED__
#define __IDxtKey_INTERFACE_DEFINED__
#include <qedit.h>
#pragma comment(lib,"strmiids.lib")

#ifndef EVF_TYPE
	#ifdef _CV_H_
		#define EVF_TYPE MEDIASUBTYPE_RGB24
	#else
		#ifdef __OPENCV_CV_H__
			#define EVF_TYPE MEDIASUBTYPE_RGB24
		#else
			#define EVF_TYPE MEDIASUBTYPE_RGB32
		#endif
	#endif
#endif

#ifdef EVF_DEBUG
	#pragma comment(lib,"quartz.lib")
#endif

//^CAEg(P:ms)
#define EVF_TIMEOUT_BUFSIZE 5000
#define EVF_TIMEOUT_PAUSE   1000
#define EVF_TIMEOUT_WAIT    1000

#define evf_release(x) {if(x)x->Release();x=0;}

int evf_cominit=0;	//COMtO(1ȂIs)
int evf_init=0;		//EMDLIB1

//\̂̒`
struct evf_struct{
	int init;						//tO
	int wx;							//摜̕
	int wy;							//摜̍
	int bit;						//摜̃rbg
	char filename[MAX_PATH];		//t@C
	unsigned char *img;				//obt@̐擪AhX
	unsigned char *pbuf;			//摜i[AhX
	volatile long bufsize;			//obt@TCY
	LONGLONG AvgTimePerFrame;		//σt[(100imbP)
	LONGLONG MaxTime;				//掞(100imbP)
	LONGLONG CurTime;				//݈ʒu(100imbP)
	int frames;						//t[
	int frame;						//݂̃t[ԍ
	IGraphBuilder *pGraphBuilder;
	IBaseFilter *pGrabberF;
	ISampleGrabber *pGrabber;
	IBaseFilter *pVmr9;
	IMediaControl *pMediaControl;
	IMediaSeeking *pMediaSeeking;
	IVideoFrameStep *pVFS;
	volatile int buf_enable;		//obt@tO
	volatile int wait;				//]tO
	volatile double SampleTime;		//Tv(b)
	volatile double _SampleTime;	//PÕTv(b)
	int count;
	int count_per_seek;		//SeekPɂBufferCB()邩
	int afterseek;
};

//ő哯I[v
#ifndef EVF_OPENMAX
	#define EVF_OPENMAX 10	
#endif

//\̂̐錾
evf_struct evf_s[EVF_OPENMAX];

//R[obN֐̒`
class evf_SampleGrabberCB :public ISampleGrabberCB
{
public:
	STDMETHODIMP_(ULONG) AddRef()
	{
		return 2;
	}
	STDMETHODIMP_(ULONG) Release()
	{
		return 1;
	}
	STDMETHODIMP QueryInterface(REFIID riid, void ** ppv)
	{
		if(riid==IID_ISampleGrabberCB || riid==IID_IUnknown){
			*ppv= (void *)static_cast<ISampleGrabberCB*>(this);
			return NOERROR;
		}
		return E_NOINTERFACE;
	}
	STDMETHODIMP SampleCB(double SampleTime, IMediaSample *pSample)
	{
		return S_OK;
	}
	//t[ɌĂ΂֐
	STDMETHODIMP BufferCB(double dblSampleTime, BYTE *pBuffer, long lBufferSize)
	{
		evf_s[i].count++;

		evf_s[i].bufsize= lBufferSize;

		if(evf_s[i].buf_enable){
			int wx= evf_s[i].wx;
			int wy= evf_s[i].wy;
			int byte= lBufferSize/wy;
			//摜̏㉺tɂăRs[
			for(int y=0; y<wy; y++){
				memcpy(evf_s[i].pbuf+(wy-1-y)*byte, pBuffer+y*byte, byte);
			}
		}

		if(evf_s[i].wait) evf_s[i].wait--;

		evf_s[i]._SampleTime= evf_s[i].SampleTime;
		evf_s[i].SampleTime= dblSampleTime;

		return S_OK;
	}
	//RXgN^	
	evf_SampleGrabberCB(int num)
	{
		i=num;
		evf_s[i].bufsize=0;
	}
	//fXgN^
	~evf_SampleGrabberCB()
	{
	}
private:
	int i;
};

evf_SampleGrabberCB *evf_pSampleGrabberCB[EVF_OPENMAX];

//ԍi͈̔̓`FbNCς݂̃`FbN
int evf_i_check(int i)
{
	if((unsigned int)i>=EVF_OPENMAX) return 1;
	if(!evf_s[i].init) return 2;
	return 0;
}

void evf_FreeMediaType(AM_MEDIA_TYPE& mt)
{
	if(mt.cbFormat){
		CoTaskMemFree((PVOID)mt.pbFormat);
		mt.cbFormat = 0;
		mt.pbFormat = NULL;
	}
	if(mt.pUnk){
		evf_release(mt.pUnk);
	}
}

void evf_DeleteMediaType(AM_MEDIA_TYPE *pmt)
{
	if(pmt){
        evf_FreeMediaType(*pmt); 
        CoTaskMemFree(pmt);
    }
}

//s̃^Cvmajortypeǂׂ(yes=1)
int evf_checkpintype(IPin *pPin, GUID majortype)
{
	HRESULT hr;
	IEnumMediaTypes *pEmt=0;
	AM_MEDIA_TYPE *pmt=0;
	int found=0;

	hr= pPin->EnumMediaTypes(&pEmt);
	while(pEmt->Next(1,&pmt,0)==S_OK){
		if(pmt->majortype == majortype){
			found=1;
			evf_DeleteMediaType(pmt);
			break;
		}
		evf_DeleteMediaType(pmt);
	}
	evf_release(pEmt);
	
	return found;
}

//tB^pFilter̃siPinDirŕwj擾
// IvV
//   majortype:̒lGUID_NULLłȂCYsƂ́CmajortypȅtƂȂ
IPin *evf_GetPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir, GUID majortype=GUID_NULL)
{
	HRESULT hr;

	IEnumPins *pEnum;
	IPin *pPin=0;
	int num=0;

	//s𒲂ׂ
	hr= pFilter->EnumPins(&pEnum);
	if(hr!=S_OK) return NULL;
	while(pEnum->Next(1,&pPin,0)==S_OK){
		//𒲂ׂ
		PIN_DIRECTION PinDirThis;
		pPin->QueryDirection(&PinDirThis);
		if(PinDir==PinDirThis) num++;
		evf_release(pPin);
	}
	evf_release(pEnum);

	hr= pFilter->EnumPins(&pEnum);
	if(hr!=S_OK) return NULL;
	while(pEnum->Next(1,&pPin,0)==S_OK){
		//𒲂ׂ
		PIN_DIRECTION PinDirThis;
		pPin->QueryDirection(&PinDirThis);
		if(PinDir==PinDirThis){
			if(majortype!=GUID_NULL && num>1){
				//sŁC^Cvw肪΃`FbN
				if(evf_checkpintype(pPin,majortype)) break;
			}else{
				break;
			}
        }
		evf_release(pPin);
	}
	evf_release(pEnum);

	return pPin;	//ꍇNULL
}

#ifdef EVF_DEBUG
//G[bZ[W̏o
void disp_err(HRESULT hr)
{
	wchar_t ptext[256];
	char text[256];
	AMGetErrorText(hr,ptext,sizeof(ptext)/sizeof(wchar_t));
	wchar_t2char(ptext,text,sizeof(text));
	ESP_PrintfU("Error:%s\n",text);
}
#endif

//C^[tF[XCIuWFNgC
void evf_objects_release(int i)
{
	evf_release(evf_s[i].pMediaSeeking);
	evf_release(evf_s[i].pVFS);
	evf_release(evf_s[i].pMediaControl);

	evf_release(evf_s[i].pGraphBuilder);

	if(evf_pSampleGrabberCB[i]){
		delete evf_pSampleGrabberCB[i];
		evf_pSampleGrabberCB[i]=0;
	}

	if(evf_s[i].img){
		delete[] evf_s[i].img;
		evf_s[i].img=0;
	}
}

//State_Paused҂(^CAEg)
int evf_waitpause(int i, DWORD step=1)
{
	OAFilterState fs;
	int t0;

	t0=GetTickCount();
	do{
		Sleep(1);
		if((GetTickCount()-t0)>(EVF_TIMEOUT_PAUSE*step)) return 1;
		evf_s[i].pMediaControl->GetState(EVF_TIMEOUT_PAUSE,&fs);
	}while(fs!=State_Paused);

	return 0;
}

//f[^]҂
int evf_waitwait(int i)
{
	int t0;

	t0=GetTickCount();
	while(evf_s[i].wait){
		Sleep(1);
		if((GetTickCount()-t0)>EVF_TIMEOUT_WAIT) return 1;
	}

	return 0;
}

//oāCPaused҂
int evf_setzero(int i)
{
	HRESULT hr;
	int r;

	evf_s[i].wait= evf_s[i].count_per_seek;

	LONGLONG pos=0;
	hr= evf_s[i].pMediaSeeking->SetPositions(&pos,AM_SEEKING_AbsolutePositioning,NULL,AM_SEEKING_NoPositioning);
	if(hr!=S_OK) return 1;
	
	r= evf_waitpause(i);
	if(r) return 2;

	r= evf_waitwait(i);
	if(r) return 3;

	evf_s[i].frame=0;
	evf_s[i].afterseek=1;
	return 0;
}

//EVF_Open()Ă΂
int evf_Open(int i, GUID mstype)
{
	HRESULT hr;
	int flagASF=0;
	int rtn;

	//t@C̊gq֕ϊ
	char *name = evf_s[i].filename;
	int len = strlen(name);
	char *ext = name+len-4;
	for(int k=0;k<4;k++){
		*(ext+k) = tolower(*(ext+k));
	}
	if(strstr(ext,".asf") || strstr(ext,".wmv")) flagASF=1;

	//t@Cwchar_t֕ϊ
	wchar_t wFilename[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,evf_s[i].filename,-1,wFilename, sizeof(wFilename)/sizeof(wchar_t));

	//FilterGraph𐶐
	hr= CoCreateInstance(CLSID_FilterGraph,NULL,CLSCTX_INPROC,IID_IGraphBuilder,(LPVOID *)&evf_s[i].pGraphBuilder);
	if(hr!=S_OK) {rtn=3; goto err_open;}

	IMediaFilter *pMediaFilter=0;

	//MediaFilter̎擾
	hr= evf_s[i].pGraphBuilder->QueryInterface(IID_IMediaFilter,(void**)&pMediaFilter);
	if(hr!=S_OK) {rtn=4; goto err_open;}

	//NbNgȂ
	hr= pMediaFilter->SetSyncSource(NULL);
	if(hr!=S_OK) {rtn=5; goto err_open;}

	evf_release(pMediaFilter);

	//MediaControl̎擾
	hr= evf_s[i].pGraphBuilder->QueryInterface(IID_IMediaControl,(LPVOID *)&evf_s[i].pMediaControl);
	if(hr!=S_OK) {rtn=6; goto err_open;}

	IBaseFilter *pReader=0;

	//-------------AsyncReader/WMAsfReader𐶐--------------------
	if(flagASF){
		hr= CoCreateInstance(CLSID_WMAsfReader,0,CLSCTX_INPROC_SERVER,IID_IBaseFilter,(void **)&pReader);
	}else{
		hr= CoCreateInstance(CLSID_AsyncReader,0,CLSCTX_INPROC_SERVER,IID_IBaseFilter,(void**)&pReader);
	}
	if(hr!=S_OK) {rtn=7; goto err_open;}

	IFileSourceFilter *pSourceF=0;

	hr= pReader->QueryInterface(IID_IFileSourceFilter,(LPVOID *)&pSourceF);
	if(hr!=S_OK) {rtn=8; goto err_open;}
	
	hr= pSourceF->Load(wFilename,NULL);
	if(hr!=S_OK) {rtn=9; goto err_open;}

	hr= evf_s[i].pGraphBuilder->AddFilter(pReader, L"FileSource");
	if(hr!=S_OK) {rtn=10; goto err_open;}
	
	evf_release(pSourceF);


	//---------------VMR9𐶐---------------
	hr= CoCreateInstance(CLSID_VideoMixingRenderer9, 0, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void**)&evf_s[i].pVmr9);
	if(hr!=S_OK) {rtn=11; goto err_open;}

	//VMR9tB^Graphɒǉ	
	hr= evf_s[i].pGraphBuilder->AddFilter(evf_s[i].pVmr9, L"VMR9");
	if(hr!=S_OK) {rtn=12; goto err_open;}


	//---------- SampleGrabber(Filter)𐶐----------------
	hr = CoCreateInstance(CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER,IID_IBaseFilter, (void**)&evf_s[i].pGrabberF);
	if(hr!=S_OK) {rtn=13; goto err_open;}

	//SampleGrabber̎擾
	evf_s[i].pGrabberF->QueryInterface(IID_ISampleGrabber, (void**)&evf_s[i].pGrabber);
	if(hr!=S_OK) {rtn=14; goto err_open;}

	AM_MEDIA_TYPE am_media_type;

	//tH[}bgw
	ZeroMemory(&am_media_type, sizeof(am_media_type));
	am_media_type.majortype= MEDIATYPE_Video;
	am_media_type.subtype= mstype;
	am_media_type.formattype= FORMAT_VideoInfo;
	hr= evf_s[i].pGrabber->SetMediaType(&am_media_type);
	if(hr!=S_OK) {rtn=15; goto err_open;}

	evf_release(evf_s[i].pGrabber);

	//SampleGrabber(Filter)Graphɒǉ	
	hr= evf_s[i].pGraphBuilder->AddFilter(evf_s[i].pGrabberF, L"SampleGrabber");
	if(hr!=S_OK) {rtn=16; goto err_open;}

	IPin *pinSout=0;
	IPin *pinGin=0;
	IPin *pinGout=0;
	IPin *pinRin=0;

	//--------sڑ---------
	//s擾
	pinSout = evf_GetPin(pReader,            PINDIR_OUTPUT, MEDIATYPE_Video);
	pinGin  = evf_GetPin(evf_s[i].pGrabberF, PINDIR_INPUT );
	pinGout = evf_GetPin(evf_s[i].pGrabberF, PINDIR_OUTPUT);
	pinRin  = evf_GetPin(evf_s[i].pVmr9,     PINDIR_INPUT );

	//\[XƃOo̐ڑ(ԃtB^͂܂)
	hr= evf_s[i].pGraphBuilder->Connect(pinSout,pinGin);
	if(hr!=S_OK && hr!=VFW_S_PARTIAL_RENDER){
		#ifdef EVF_DEBUG
		disp_err(hr);
		#endif
		rtn=17; goto err_open;
	}

	//Ooƃ_̐ڑ(ԃtB^͂܂)
	hr= evf_s[i].pGraphBuilder->Connect(pinGout,pinRin);
	if(hr!=S_OK && hr!=VFW_S_PARTIAL_RENDER){
		#ifdef EVF_DEBUG
		disp_err(hr);
		#endif
		rtn=18; goto err_open;
	}

	//s
	evf_release(pinSout);
	evf_release(pinGin);
	evf_release(pinGout);
	evf_release(pinRin);

	evf_release(pReader);
	evf_release(evf_s[i].pVmr9);

	//rfIEBhE\ɂ
	IVideoWindow *pVidWin=0;
	hr= evf_s[i].pGraphBuilder->QueryInterface(IID_IVideoWindow,(void**)&pVidWin);
	if(hr!=S_OK) {rtn=19; goto err_open;}
	pVidWin->put_AutoShow(OAFALSE);
	evf_release(pVidWin);

	//SampleGrabber̎擾
	evf_s[i].pGrabberF->QueryInterface(IID_ISampleGrabber, (void**)&evf_s[i].pGrabber);
	if(hr!=S_OK) {rtn=20; goto err_open;}

	hr= evf_s[i].pGrabber->SetBufferSamples(FALSE);
	if(hr!=S_OK) {rtn=21; goto err_open;}

	hr= evf_s[i].pGrabber->SetOneShot(FALSE);
	if(hr!=S_OK) {rtn=22; goto err_open;}

	//R[obN֐̓o^
	evf_pSampleGrabberCB[i]= new evf_SampleGrabberCB(i);
	hr= evf_s[i].pGrabber->SetCallback(evf_pSampleGrabberCB[i],1);
	if(hr!=S_OK) {rtn=23; goto err_open;}

	//PauseԂɂčŏ̃Tv҂
	evf_s[i].pMediaControl->Pause();

	//PȏTv(obt@TCYm肷)܂őҋ@
	int t0=GetTickCount();
	do{
		Sleep(1);
		if((GetTickCount()-t0)>EVF_TIMEOUT_BUFSIZE) {rtn=24; goto err_open;}
	}while(evf_s[i].bufsize==0);

	//obt@̊m
	evf_s[i].img = (unsigned char*)new char[evf_s[i].bufsize];	
	if(!evf_s[i].img) {rtn=25; goto err_open;}
	
	evf_s[i].pbuf = evf_s[i].img;

	//obt@mۊtO
	evf_s[i].buf_enable=1;

	//̎擾
	hr= evf_s[i].pGrabber->GetConnectedMediaType(&am_media_type);
	if(hr!=S_OK){
		#ifdef EVF_DEBUG
		disp_err(hr);
		#endif
		rtn=26; goto err_open;
	}else{
		//CCrbgCσt[Ԃ̎擾
		VIDEOINFOHEADER *pVideoInfoHeader =	(VIDEOINFOHEADER *)am_media_type.pbFormat;
		evf_s[i].wx = pVideoInfoHeader->bmiHeader.biWidth;
		evf_s[i].wy = pVideoInfoHeader->bmiHeader.biHeight;
		evf_s[i].bit= pVideoInfoHeader->bmiHeader.biBitCount;
		evf_s[i].AvgTimePerFrame = pVideoInfoHeader->AvgTimePerFrame;
		evf_FreeMediaType(am_media_type);
	}

	evf_release(evf_s[i].pGrabber);
	evf_release(evf_s[i].pGrabberF);

	//VideoFrameStep̎擾
	hr= evf_s[i].pGraphBuilder->QueryInterface(IID_IVideoFrameStep, (LPVOID *)&evf_s[i].pVFS);
	if(hr!=S_OK) {rtn=27; goto err_open;}

	evf_s[i].afterseek=1;

	//MediaSeeking̎擾
	hr= evf_s[i].pGraphBuilder->QueryInterface(IID_IMediaSeeking, (void**)&evf_s[i].pMediaSeeking);
	if(hr!=S_OK) {rtn=28; goto err_open;}

	//掞Ԃ̎擾(P:100ns)
	hr= evf_s[i].pMediaSeeking->GetDuration(&evf_s[i].MaxTime);
	if(hr!=S_OK) {rtn=29; goto err_open;}

	//seekBufferCB()Ăяo񐔂̕ۑit@CPC\ɂĈႤ߁j
	Sleep(33);
	evf_s[i].count_per_seek= evf_s[i].count;

	//t[̐
	if(evf_s[i].AvgTimePerFrame){
		evf_s[i].frames = (int)(evf_s[i].MaxTime / evf_s[i].AvgTimePerFrame);
	}else{
		//AvgTimePerFrame=0łTv^CԊu擾łΐݒ肷
		double period= evf_s[i].SampleTime - evf_s[i]._SampleTime;
		if(period>0.0){
			evf_s[i].AvgTimePerFrame = (LONGLONG)(period * 10000000.);
			evf_s[i].frames = (int)(evf_s[i].MaxTime / evf_s[i].AvgTimePerFrame);
		}
	}

	//o
	evf_setzero(i);

	evf_s[i].init=1;	//tO
	return 0;

err_open:
	//G[I
	evf_objects_release(i);
	return rtn;
}

//t@CJ
int EVF_Open(int i, char *filename, GUID mstype=EVF_TYPE)
{
	HRESULT hr;

	//͈̓`FbN
	if((unsigned int)i>=EVF_OPENMAX) return 1;

	//x.init̏
	if(!evf_init){
		for(int j=0;j<EVF_OPENMAX;j++) evf_s[j].init=0;
		evf_init=1;
	}

	//ɊJĂH
	if(evf_s[i].init) return 2;

	//COM̏
	if(!evf_cominit){
		hr= CoInitializeEx(NULL,COINIT_MULTITHREADED);
		if(hr==S_OK) evf_cominit=1;	//tO𗧂Ă
	}

	//\̂̏
	ZeroMemory(&evf_s[i],sizeof(evf_struct));

	//t@C̃Rs[
	strcpy_s(evf_s[i].filename,sizeof(evf_s[i].filename),filename);

	//c̏
	return evf_Open(i,mstype);
}

//̃t[֐i߂
int EVF_Next(int i, int step=1)
{
	HRESULT hr;
	unsigned int t0;
	int r;

	if(evf_i_check(i)) return 1;

	//Seek͂P]Step()Kv̂悤
	if(evf_s[i].afterseek){
		evf_s[i].afterseek=0;

		hr= evf_s[i].pVFS->Step(1,NULL);
		if(hr!=S_OK) return 2;

		r= evf_waitpause(i);
		if(r) return 3;
	}

	//̃t[
	evf_s[i].wait= 1;
	hr= evf_s[i].pVFS->Step(step,NULL);
	if(hr!=S_OK) return 4;

	//State_Paused҂CPauseȂΓoCI
	r= evf_waitpause(i,step);
	if(r){
		evf_s[i].pMediaControl->Pause();
		evf_setzero(i);
		return 5;
	}

	//f[^]҂Cf[^ȂΓoCI
	t0=GetTickCount();
	while(evf_s[i].wait){
		Sleep(1);
		if((GetTickCount()-t0)>EVF_TIMEOUT_WAIT){
			evf_setzero(i);
			return 5;
		}
	}

	evf_s[i].frame += step;

	return 0;
}

//wt[܂ŃV[N
int EVF_Seek(int i, int frame)
{
	HRESULT hr;
	int t0;

	if(evf_i_check(i)) return 1;

	//wt[
	LONGLONG pos;
	pos = evf_s[i].AvgTimePerFrame * (LONGLONG)frame;
	
	evf_s[i].wait= evf_s[i].count_per_seek;

	hr= evf_s[i].pMediaSeeking->SetPositions(&pos,AM_SEEKING_AbsolutePositioning,NULL,AM_SEEKING_NoPositioning);
	if(hr!=S_OK) return 2;

	evf_s[i].afterseek= 1;

	//State_Paused҂ƍĐI
	OAFilterState fs;
	do{
		hr= evf_s[i].pMediaSeeking->GetCurrentPosition(&pos);
		if(hr==S_OK){
			//݈ʒu擾łC̒lŏI
			evf_s[i].CurTime = pos;
			if(pos>=evf_s[i].MaxTime){
				evf_s[i].pMediaControl->Pause();
				evf_setzero(i);
				return 5;
			}
		}else{
			//擾łȂ΁Ct[ԍŏI
			if((evf_s[i].frame+1)>=evf_s[i].frames){
				evf_s[i].pMediaControl->Pause();
				evf_setzero(i);
				return 5;
			}
		}
		evf_s[i].pMediaControl->GetState(EVF_TIMEOUT_PAUSE,&fs);
	}while(fs!=State_Paused);

	//f[^]҂Cf[^ȂΏI
	t0=GetTickCount();
	while(evf_s[i].wait){
		Sleep(1);
		if((GetTickCount()-t0)>EVF_TIMEOUT_WAIT){
			evf_setzero(i);
			return 5;
		}
	}
	
	evf_s[i].frame = frame;

	return 0;
}

//摜֊i[ (`(24or32)̂܂)
int EVF_GetFrame(int i, void *dst)
{
	if(evf_i_check(i)) return 1;
	//摜f[^̃Rs[
	memcpy(dst, evf_s[i].img, evf_s[i].bufsize);
	return 0;
}

//摜摜ϊ(24rbg->32rbg)Ȃ烁֊i[
int EVF_GetFrame24to32(int i, int *dst)
{
	if(evf_i_check(i)) return 1;

	unsigned char R,G,B;
	int wx=evf_s[i].wx;
	int wy=evf_s[i].wy;
	int *p;
	unsigned char *src=evf_s[i].img;
	int byte= evf_s[i].bufsize/wy;
	unsigned char *s;

	for(int y=0;y<wy;y++){
		s = src;
		p = dst + wx*y;
		for(int x=0;x<wx;x++){
			B = *(s+0);
			G = *(s+1);
			R = *(s+2);
			*p++ = (R<<16) | (G<<8) | B;
			s+=3;
		}
		src += byte;
	}
	return 0;
}

//t@C
int EVF_Close(int i)
{
	if(evf_i_check(i)) return 1;

	evf_objects_release(i);
	Sleep(1);	//ꂪȂXPł

	evf_s[i].init=0;

	int c=0;
	for(int j=0;j<EVF_OPENMAX;j++){
		if(evf_s[j].init) c++;
	}

	//COM̉ (ׂĕ  COM̏Ă)
	if(c==0 && evf_cominit){
		CoUninitialize();
		evf_cominit=0;
	}
	return 0;
}

//t[(frame)
int EVF_Frames(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].frames;
}

//݂̃t[ԍ
int EVF_Frame(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].frame;
}

//σt[(P:100imb)
LONGLONG EVF_AvgTime(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].AvgTimePerFrame;
}

//掞(P:100imb)
LONGLONG EVF_MaxTime(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].MaxTime;
}

//݈ʒu(P:100imb)
LONGLONG EVF_CurTime(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].CurTime;
}

//t[[g(fps)
double EVF_FrameRate(int i)
{
	if(evf_i_check(i)) return 0;
	if(evf_s[i].AvgTimePerFrame){
		return 10000000./(double)evf_s[i].AvgTimePerFrame;
	}else{
		return 0.0;
	}
}

//TCY(pixel)
int EVF_WX(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].wx;
}

//cTCY(pixel)
int EVF_WY(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].wy;
}

//rbg(bit)
int EVF_Bit(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].bit;
}

//obt@TCY(byte)
int EVF_BufferSize(int i)
{
	if(evf_i_check(i)) return 0;
	return evf_s[i].bufsize;
}

//obt@AhX̕ύX
int EVF_SetBuffer(int i, void *buffer)
{
	if(evf_i_check(i)) return 1;
	evf_s[i].pbuf= (unsigned char *)buffer;
	return 0;
}
